'use strict';
const PConst = require("./ProxyConsts.js");
var server = require('./EdgeSideServer.js');
const log = require('../../../utils/log');

var JobManagerProxy = function () {
};
/**
 * 发送ifttt或者script的执行状态给jobmanager
 *
 * @param  {[type]} jobstatus [job的执行状态，格式如下：
 * {
        "ackCode" : int
        "jobId" :   long
        "jobStatus" : int // 1：未运行 2:运行中 3:执行完成 4:执行失败 5:被挂起
        "executor" : string
        "result" : string
    }
]
 * @return {[type]}           [description]
 */
JobManagerProxy.prototype.sendJobStatus = function(jobstatus) {
    log.i("WS", "JobManagerProxy.sendJobStatus: " + JSON.stringify(jobstatus));
    var args = undefined;
    if (typeof jobstatus === 'object') {
        args = JSON.stringify(jobstatus);
    } else if (typeof jobstatus === 'string') {
        args = jobstatus;
    } else {
        // args will be ignored.
    }
    return server.sendSignal("jobstatus_event", args);
};

module.exports = new JobManagerProxy();
