const log = require('./log.js');

const TAG = '[MockDServer]';

function MockDServer(wellknowName, objPath) {
  log.d(TAG, `new MockDServer ==> wellknowName: ${wellknowName}, objPath:${objPath}`);
}

MockDServer.prototype.start = function () {
  log.d(TAG, 'start...');

};

MockDServer.prototype.prepare = function () {
  return true;
};

MockDServer.prototype.stop = function () {
  log.d(TAG, 'stop...');

};

MockDServer.prototype.addMatch = function (rule) {
  log.d(TAG, `addMatch ==> rule: ${rule}`);

};

MockDServer.prototype.removeMatch = function (rule) {
  log.d(TAG, `removeMatch ==> rule: ${rule}`);

};

/**
 * callback(signal, sender, args)
 * @param event
 * @param callback
 */
MockDServer.prototype.on = function (event, callback) {
  log.d(TAG, `on ==> event: ${event}`);
  if (event === 'signal') {

  } else if (event === 'method_call') {
    log.d(TAG, 'on(method_call), do nothing');
  } else {
    log.e(TAG, 'on(method_call), do nothing');
  }
};

MockDServer.prototype.sendSignal = function (signal, args) {
  log.d(TAG, `sendSignal ==> signal: ${signal}, args: ${JSON.stringify(args)}`);

};

MockDServer.prototype.traceLog = function (...args) { // level, tag, file, func, line, log
  log.t(...args);
};

module.exports = MockDServer;