var Group = require("../Group");
const TAG = "api_test wxm";
const assert = require("assert");
const linkedge = require("../linkedge");
var group = new Group(1);

function test_getDeviceByPkDn() {
    group.getDeviceByPkDn("a1HtrQxTVw0", "wxm001", function (err, thing) {
    console.log("getDeviceByPkDn thing = " + JSON.stringify(thing));
});
}


function test_getDevicesByTag() {
    group.getDevicesByTag([{"key": "wxm", "value": "fan"}], function (err, devices) {
        console.log(TAG, "getDevicesByTag err =" + err);
        console.log(TAG, "getDevicesByTag devices =" + JSON.stringify(devices));
    });
}

function test_getConfigByGroupId() {
    var api_group = require("../api-group");
    var expectObject = {
        "devices": [{
            "deviceName": "wxm001",
            "productKey": "a1HtrQxTVw0",
            "tags": [{"key": "wxm", "value": "fan"}, {"key": "device", "value": "device1"}]
        }, {
            "deviceName": "abcde",
            "productKey": "obj2",
            "tags": [{"key": "wxm", "value": "light"}, {"key": "device", "value": "device2"}]
        }], "groupId": 1, "name": "小敏FC_API分组"
    };
    api_group.getConfigByGroupId(1, function (err, config) {
        console.log(TAG, "getConfigByGroupId config = " + JSON.stringify(config));
        assert.equal(JSON.stringify(config), JSON.stringify(expectObject));
    });
    api_group.getConfigByGroupId(100, function (err, config) {
        console.log(TAG, `getConfigByGroupId err= ${err}`+ "config = " + JSON.stringify(config));
        assert.equal(config, undefined);
    });
    var expectObject1 = {"devices":[{"deviceName":"wxm004","productKey":"a1HtrQxTVw0","tags":[]},{"deviceName":"wxm003","productKey":"a1HtrQxTVw0","tags":[{"key":"aa","value":"bbb"}]},{"deviceName":"wxm002","productKey":"a1HtrQxTVw0","tags":[{"key":"Spa","value":"hello"}]},{"deviceName":"wxm001","productKey":"a1HtrQxTVw0","tags":[{"key":"keyzhong","value":"中国好人们赶快和"}]}],"groupId":134430,"name":"小敏分组"};
    api_group.getConfigByGroupId(134430, function (err, config) {
        console.log(TAG, `getConfigByGroupId err= ${err}`+ "config = " + JSON.stringify(config));
        assert.equal(JSON.stringify(config), JSON.stringify(expectObject1));
    });

}

function test_getTag() {
    const event = {
        "type":"deviceEvent",
        "payload":{
            "id":"a1mbc0sgd6G_ 1e0c0f0b",
            "eventName":"high_temprature",
            "params":{
                "num":30
            },
            "eventType":1
        },
        "provider":{
            "productKey":"a1mbc0sgd6G",
            "deviceName":"1e0c0f0b",
            "groupId":1
        }
    }
    linkedge.getTag(event, "wxm", function (err, tag) {
        console.log(TAG, "err = " + err + "tag =" + JSON.stringify(tag));
    });
}

function test_getDevicesByProductKey() {

}

function test_group() {
    const Log = require("../Log");
    const linkedge = require("../linkedge");
    const TAG = "API_test_MY";
    const event = {
        "type":"deviceEvent",
        "payload":{
            "id":"a1mbc0sgd6G_ 1e0c0f0b",
            "eventName":"high_temprature",
            "params":{
                "num":30
            },
            "eventType":1
        },
        "provider":{
            "productKey":"a1mbc0sgd6G",
            "deviceName":"1e0c0f0b",
            "groupId":1
        }
    }
    var group = linkedge.getGroupByEvent(event);
    console.log("wxm_test", "group = " + JSON.stringify(group));
    console.assert(group.groupId==1, "group is wrong");
    group.getDeviceByPkDn("a1mbc0sgd6G", "1e0c0f0b", function (err, device) {
        console.log(TAG, "getDeviceByPkDn err" + err );
        if(!err) {
            console.log(TAG, "==============test_case11 test OK!getDeviceByPkDn device = " + JSON.stringify(device));
        }
    });
}

// test_getDeviceByPkDn();
// test_getDevicesByTag();
// test_group();
// test_getTag();
test_getConfigByGroupId();