//
// Copyright (c) 2017 Alibaba Group Holding Ltd.
// All rights reversed.
//
var DataCenter = require("./DataCenter");

function Registry() {
}

/**
 * @description 判断是否已经有这个设备
 * @return {bool}
 */
Registry.prototype.hasThing = function(id) {
    return DataCenter.hasThing(id);
};

/**
 * @description 删除设备入口
 * @param {String} id
 **/
Registry.prototype.removeThing = function (id) {
    return DataCenter.deleteDevice(id);
};

/**
 * @description 获取实例化设备列表
 * @returns {Array}
 */
Registry.prototype.getThings = function() {
  return DataCenter.getDeviceObjectList();
};

/**
 * @description 获取id对应的实例化device
 * @param id
 * @returns {DynamicDevice} device对象
 */
Registry.prototype.getThing = function(id) {
  return DataCenter.getDeviceObject(id);
};

Registry.prototype.isThing = function (objectOrId) {
    var thing;
    if (typeof objectOrId === 'string') {
        thing = this.getThing(objectOrId);
    } else {
        thing = objectOrId;
    }
    if (!thing || JSON.stringify(thing) === "{}") {
        return false;
    }
    return true;
};


module.exports = new Registry();
