#!/bin/bash
if [ $# -lt 3 ] ; then
    echo "USAGE: $0 ProductKey DeviceName DeviceSecret [Host] [Port]. '[..]' are optional parameters."
    exit 1;
fi

cd $(readlink -f $(dirname $0))/../bin
./deploy_sst
sleep 0.1
./mbusd
sleep 0.1
./startConfigmanager.sh &>/dev/null &
sleep 0.1

./tool_config -s gw_dimu_devicetuple "[[\"$1\",\"$2\",\"$3\"]]"
./tool_config -s gw_system_productkey "$1"
./tool_config -s gw_system_devicename "$2"
./tool_config -s gw_system_devicesecret "$3"

if [ $# == 5 ] ; then
    ./tool_config -s gw_system_as_host "$4"
    ./tool_config -s gw_system_as_port "$5"
fi

sleep 1 # wait configuration save to disk
# kill config-manager to make sure the config is saved
ps -eo user,pid,ppid,stat,args | grep "config-manager" | grep -v "grep" | awk '{print $2}' | xargs kill -15 
sleep 1 # wait configuration save to disk
cd -
