#! /bin/bash

cd `dirname $0`

service_array=(startConfigmanager.sh logger  startDatamanager.sh watch-dog cloud-proxy dimu message-router fota gateway-monitor task-dispatcher credential startFC.sh service-monitor RemoteTerminalDaemon)

#export LD_LIBRARY_PATH=$(readlink -f ../lib/):$(readlink -f ../lib/db-storage/):$(readlink -f ../lib/pg/):$(readlink -f ../lib/sqlite):$(readlink -f ../usr/lib-sz):$LD_LIBRARY_PATH

pids=`ps -eo user,pid,ppid,stat,args | grep redis | grep -v grep | awk '{print $2}'`
if [ -n "$pids" ]; then
${Q}echo -e "[    \033[0;31m-\033[0m    ]  Stop Running Service: redis"
    kill -9 $pids >>/tmp/linkedge.log 2>&1
fi

start_services(){
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: sst"
	../bin/deploy_sst >>/tmp/linkedge.log 2>&1
    
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: redis-server"
	cd ../bin && ./redis-server ./../config/redis.conf >>/tmp/linkedge.log 2>&1 &

	#first start the mbus
	cd ../bin && ./mbusd >>/tmp/linkedge.log 2>&1 && cd - &>/dev/null
	sleep 0.01
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: mbusd"

	
	#second loop start service
	i=0
	for service in ${service_array[@]}
	do
		cd ../bin
		if [ "${service}" = "logger" ];
		then
			(./${service} && sleep 0.1)
		else
			(./${service} &>/dev/null &)
		fi
	cd - &>/dev/null
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: ${service}"
	sleep 0.03
	i=$i+1
    done
}


${Q}echo "----------------------------------------------------------"
${Q}echo -e "                 \033[32mStart Link IoT Edge Service\033[0m    "
${Q}echo "----------------------------------------------------------"
${Q}echo ""
start_services
${Q}echo ""

